SparkFun MAG3110 Breakout Board Arduino Library
============================================
Arduino Library for the SparkFun Triple Axis Magnetometer Breakout - MAG3110

This library makes it easy for you to get started with the MAG3110 breakout board. It also has commands included for more advanced users that want to squeeze even more functionality out of the MAG3110.

You will also be able to calibrate the MAG3110 whenever necessary as shown in the example.

SparkFun MAG3110 Arduino Library
========================================

[![SparkFun MAG3110](https://cdn.sparkfun.com//assets/parts/9/3/9/8/12670-01.jpg)](https://www.sparkfun.com/products/12670)

[*SparkFun Triple Axis Magnetometer Breakout - MAG3110*](https://www.sparkfun.com/products/12670)

Freescale’s MAG3110 is a small, low-power, digital 3-axis magnetometer. The device can be used in conjunction with a 3-axis accelerometer to produce orientation independent accurate compass heading information. It features a standard I2C serial interface output and smart embedded functions. It’s also a tiny QFN package which isn’t very easy to play with so here is our easy to use breakout board. This board breaks out all of the pins for the MAG3110 to a standard 0.1" header and also supplies the necessary filtering capacitors so that you can easily use it in your next navigation project.

This library includes functions that allow you to read your heading to magnetic north. Data from this is output on the range of -180 degrees to +180 degrees.


Repository Contents
-------------------

* **/examples** - Example sketches for the library (.ino). Run these from the Arduino IDE. 
* **/src** - Source files for the library (.cpp, .h).
* **library.properties** - General library properties for the Arduino package manager. 


Documentation
--------------

* **[Installing an Arduino Library Guide](https://learn.sparkfun.com/tutorials/installing-an-arduino-library)** - Basic information on how to install an Arduino library.
* **[Product Repository](https://github.com/sparkfun/MAG3110_Breakout_Board)** - Main repository (including hardware files).
* **[Hookup Guide](https://learn.sparkfun.com/tutorials/mag3110-magnetometer-hookup-guide-)** - Basic hookup guide.

Products that use this Library 
---------------------------------

* [SparkFun Triple Axis Magnetometer Breakout - MAG3110 - SEN-12670 ](https://www.sparkfun.com/products/12670)- MAG3110 is a small, low-power, digital 3-axis magnetometer. The device can be used in conjunction with a 3-axis accelerometer to produce orientation independent accurate compass heading information. It features a standard I2C serial interface output and smart embedded functions. It’s also a tiny QFN package which isn’t very easy to play with so here is our easy to use breakout board. This board breaks out all of the pins for the MAG3110 to a standard 0.1" header and also supplies the necessary filtering capacitors so that you can easily use it in your next navigation project.

Version History
---------------

* [1.0.0]() - Initial release of the Triple Axis Accelerometer Breakout - MAG3110 SparkFun Library.

License Information
-------------------

This product is _**open source**_! 

Please review the LICENSE.md file for license information. 

If you have any questions or concerns on licensing, please contact techsupport@sparkfun.com.

Distributed as-is; no warranty is given.

- Your friends at SparkFun. And George the contract author :)





