SparkFun SparkFun Motor Driver - Dual TB6612FNG (1A) Arduino Library
=====================================================================

![SparkFun Motor Driver - Dual TB6612FNG (1A)](https://cdn.sparkfun.com//assets/parts/3/1/5/7/09457-01b.jpg)

[*SparkFun Motor Driver - Dual TB6612FNG (1A) (ROB-0457)*](https://www.sparkfun.com/products/9457)

The TB6612FNG motor driver can control up to two DC motors at a constant current of 1.2A (3.2A peak). 
Two input signals (IN1 and IN2) can be used to control the motor in one of four function modes - CW, CCW, short-brake, and stop. 
The two motor outputs (A and B) can be separately controlled, the speed of each motor is controlled via a PWM input signal with a frequency up to 100kHz. 
The STBY pin should be pulled high to take the motor out of standby mode.

Repository Contents
-------------------

* **/examples** - Example sketches for the library (.ino). Run these from the Arduino IDE. 
* **/extras** - Additional documentation for the user. These files are ignored by the IDE. 
* **/src** - Source files for the library (.cpp, .h).
* **keywords.txt** - Keywords from this library that will be highlighted in the Arduino IDE. 
* **library.properties** - General library properties for the Arduino package manager. 

Documentation
--------------

* **[Installing an Arduino Library Guide](https://learn.sparkfun.com/tutorials/installing-an-arduino-library)** - Basic information on how to install an Arduino library.
* **[Product Repository](https://github.com/sparkfun/Motor_Driver-Dual_TB6612FNG/tree/V_1.1)** - Main repository (including hardware files) for the TB6612FNG Motor Driver.
* **[Hookup Guide](https://learn.sparkfun.com/tutorials/tb6612fng-hookup-guide)** - Basic hookup guide for the TB6612FNG Motor Driver.

Products that use this Library 
---------------------------------

* [ROB-09457](https://www.sparkfun.com/products/9457)- Motor Driver
* [ROB-13845](https://www.sparkfun.com/products/13845)- Motor Driver with headers installed


License Information
-------------------

This product is _**open source**_! 

Please review the LICENSE.md file for license information. 

If you have any questions or concerns on licensing, please contact techsupport@sparkfun.com.

Distributed as-is; no warranty is given.

- Your friends at SparkFun.


